library ieee;
use ieee.std_logic_1164.all;
use work.pack_2.all;

entity sar is
  port (r,c,d : in X01; z : out X01_vector(2 downto 0));
end sar;

architecture structure of sar is
  component sn7400 is -- 1/4 SN7400
    port (x : in X01_vector (1 to 2); y : out X01);
  end component;
  component sn7472 is -- SN7472
    port (s_b,r_b,c : in X01; j,k : in X01_vector(1 to 3); q,q_b : out X01);
  end component;
  
  alias z2 : X01 is z(2);
  alias z1 : X01 is z(1);
  alias z0 : X01 is z(0);
  
  signal nd : X01; -- nicht d
  signal q2, q1, q0, nq2, nq1, nq0 : X01;
begin
  not1: sn7400 port map(x(1)=>d, x(2)=>d, y=>nd);
  
  jk2:  sn7472 port map(s_b=>r, r_b=>'1', c=>c,
                        j(1)=>'0', j(2)=>'1', j(3)=>'1',
                        k(1)=>nd,  k(2)=>nq1, k(3)=>nq0,
                        q=>z2, q_b=>nq2);
                        
  jk1:  sn7472 port map(s_b=>'1', r_b=>r, c=>c,
                        j(1)=>nq0, j(2)=>'1', j(3)=>'1',
                        k(1)=>nd,  k(2)=>nq0, k(3)=>'1',
                        q=>z1, q_b=>nq1);
  
  jk0:  sn7472 port map(s_b=>'1', r_b=>r, c=>c,
                        j(1)=>q1,  j(2)=>'1', j(3)=>'1',
                        k(1)=>nd,  k(2)=>'1', k(3)=>'1',
                        q=>z0, q_b=>nq0);
  
  not2: sn7400 port map(x(1)=>nq2, x(2)=>nq2, y=>q2);
  not3: sn7400 port map(x(1)=>nq1, x(2)=>nq1, y=>q1);
  not4: sn7400 port map(x(1)=>nq0, x(2)=>nq0, y=>q0);
end structure;
