library ieee;
use ieee.std_logic_1164.all;                               
use work.pack_2.all;                                       
                                                         
entity uut is                                            
  port (x_fghij : in  X01_vector(20 downto 13);
        z_abcde : out X01_vector(20 downto 13));       
end uut;                                                 
                                                       
architecture structure of uut is
  alias r     : x01 is x_fghij(20);
  alias c     : x01 is x_fghij(19);
  component comparator
    port (ue,uz : in natural; d : out X01);
  end component;
  component sar
    port (r,c,d : in X01; z : out X01_vector(2 downto 0));
  end component;
  component dac
    port (z : in X01_vector(2 downto 0); uz : out natural);
  end component;
  signal d  : X01;
  signal ue : natural := 400; -- default
  signal uz : natural;
  signal z  : X01_vector(2 downto 0);  
begin
  u1: comparator port map (ue,uz,d);
  u2: sar        port map (r,c,d,z);
  u3: dac        port map (z,uz);
  z_abcde(20 downto 18) <= z;
end structure;
